extern unsigned int width, height, GridHeight, GridWidth,GridX,GridY;
extern unsigned int mess[], im;
extern float ref;	     //Torzeit in Sekunden (Ausgabe)
extern float fact;	     //Frequenz-Korrekturfaktor
extern char clock;	     //Referenz-Vorteiler-Faktor
extern unsigned int pre;     //Prescaler-Faktor
extern float accuracy;	     //Genauigkeit in Hz (Ausgabe)
extern float fo, fu;
extern int Trace[];
extern char erase;


void plot2(BYTE col)	//2. Segment schreiben, 1. lschen
{
unsigned int seg=1025, old=1, dp, wp;
if (erase)
 {
  dp=GridX;
  wp=GridX;
  set_color(0);
  putvline(dp,mess[old],mess[old+1]);
  old++;
  dp++;
  do {
    putvline(dp,mess[old],mess[old+1]);
    set_color(col);
    putvline(wp,mess[seg],mess[seg+1]);
    set_color(0);
    old++; dp++; seg++; wp++;
     } while (dp < width);
  set_color(col);
  putvline(wp,mess[seg],mess[seg+1]);
  }
else
  {
  wp=GridX;
  set_color(col);
  do {
      putvline(wp,mess[seg],mess[seg+1]);
      seg++; wp++;
     } while (wp < width);
  }
}

void plot3(BYTE col)	//3. Segment schreiben, 2. lschen
{
unsigned int seg=2049, old=1025, dp, wp;
if (erase)
  {
  dp=GridX;
  wp=GridX;
  set_color(0);
  putvline(dp,mess[old],mess[old+1]);
  old++;
  dp++;
  do {
      putvline(dp,mess[old],mess[old+1]);
      set_color(col);
      putvline(wp,mess[seg],mess[seg+1]);
      set_color(0);
      old++; dp++; seg++; wp++;
     } while (dp < width);
  set_color(col);
  putvline(wp,mess[seg],mess[seg+1]);
  }
else
  {
  wp=GridX;
  set_color(col);
  do {
      putvline(wp,mess[seg],mess[seg+1]);
      seg++; wp++;
     } while (wp < width);
  }
}


void plot4(BYTE col)	//4. Segment schreiben, 3. lschen
{
unsigned int seg=3073, old=2049, dp, wp;
if (erase)
  {
  dp=GridX;
  wp=GridX;
  set_color(0);
  putvline(dp,mess[old],mess[old+1]);
  old++;
  dp++;
  do {
      putvline(dp,mess[old],mess[old+1]);
      set_color(col);
      putvline(wp,mess[seg],mess[seg+1]);
      set_color(0);
      old++; dp++; seg++; wp++;
     } while (dp < width);
  set_color(col);
  putvline(wp,mess[seg],mess[seg+1]);
  }
else
  {
  wp=GridX;
  set_color(col);
  do {
      putvline(wp,mess[seg],mess[seg+1]);
      seg++; wp++;
     } while (wp < width);
  }
}

void plot1(BYTE col)	//1. Segment schreiben, 4. lschen
{
unsigned int seg=1, old=3073, dp, wp;
if (erase)
  {
  dp=GridX;
  wp=GridX;
  set_color(0);
  putvline(dp,mess[old],mess[old+1]);
  old++;
  dp++;
  do {
      putvline(dp,mess[old],mess[old+1]);
      set_color(col);
      putvline(wp,mess[seg],mess[seg+1]);
      set_color(0);
      old++; dp++; seg++; wp++;
     } while (dp < width);
  set_color(col);
  putvline(wp,mess[seg],mess[seg+1]);
  }
else
  {
  wp=GridX;
  set_color(col);
  do {
      putvline(wp,mess[seg],mess[seg+1]);
      seg++; wp++;
     } while (wp < width);
  }
}

void put_db(int dbmax, int deltadb)
{
char Line[128], Line2[128];
out_Sequencer(0x2,15);	 //alle Bitplanes schreiben
strcpy(Line,"Ref = ");
strcat(Line,itoa( dbmax, Line2, 10));
strcat(Line,"dB   ");
PutString(0,0,Line,15);

itoa( deltadb/10, Line, 10);
if (deltadb==5) strcpy(Line,"0.5");
strcat(Line,"dB/  ");
strxfrm(Line2, Line, 6);
PutString(0,24,Line2,1);
out_Sequencer(0x2,2);
}

void init_counter(void)
{
const pa1=0x1e0;
const pb1=0x1e2;
const pc1=0x1e4;
const co1=0x1e6;
const pa2=0x120;
const pb2=0x121;
const pc2=0x122;
const co2=0x123;
char i;

outp(co2,128);    //Ports auf Ausgabe
outp(co1,137);    //A,B aus  C ein
outp(pc1,0xff);
outp(pb1,clock | 0xe0);
ref=1.e-7;
for (i=1; i<=clock; i++) ref=ref*2;
ref=ref-2e-7;
}

float frequenz(void)
{
const pa1=0x1e0;
const pb1=0x1e2;
const pc1=0x1e4;
const co1=0x1e6;
const pa2=0x120;
const pb2=0x121;
const pc2=0x122;
const co2=0x123;
unsigned long int *cnt;
char d[4];
float result;
cnt=d;
*cnt=0;
//  do ; while ((inp(pc1) & 1)==0);  geht aufgrund Softwaredelays auch ohne!
  outp(pb1,clock | 0x60);
  d[2]=inp(pc1);
  outp(pb1,clock | 0xa0);
  d[1]=inp(pc1);
  outp(pb1,clock | 0xc0);
  d[0]=inp(pc1);
  outp(pb1,clock | 0xe0);
  result=*cnt/ref/1.e6*pre*fact;
  accuracy=1/ref*pre;
  return(result);
}

void save_trace(int anz, char name[])
{
FILE *pFile;
int i;
float f;
pFile=fopen (name,"wt");
for (i=0;i<anz;i++)
  {
  f=fo+i*(fu-fo)/anz;
  fprintf(pFile,"%f %f\n",f+f_adder, dbmess[i]/100.);
  }
fclose(pFile);
}

void plot_trace(BYTE plane, BYTE col)
{
unsigned int seg=0, wp;
wp=GridX;
out_Sequencer(0x2,plane);   //alle Bitplanes schreiben
set_color(col);
do {
    putvline(wp,Trace[seg],Trace[seg+1]);
    seg++; wp++;
   } while (seg < GridWidth-1);
out_Sequencer(0x2,2);	 //Bit-Plane 2
}

void out_thru(void)
{
out_Sequencer(0x2,15);	 //alle Bit-Planes
if (thru) PutString(0,48,"Thru",1);
else PutString(0,48,"    ",1);
out_Sequencer(0x2,2);	 //Bit-Plane 2
}

void out_debug(int i, int j)
{
char Line[128],Line2[128];
out_Sequencer(0x2,13);   //alle Bitplanes schreiben
strcpy(Line,"Debug = ");
strcat(Line,itoa( i, Line2, 10));
strcat(Line,"  ");
strcat(Line,itoa( j, Line2, 10));
PutString(200,0,Line,15);

out_Sequencer(0x2,2);
}

void inttofile(int vec[], int anz, char name[])
{
  FILE *pFile;
  int i;
  pFile=fopen (name,"wt");
  for (i=0; i<anz; i++)
  fprintf(pFile,"%i\n",vec[i]);
  fclose(pFile);
}

void floattofile(float vec[], int anz, char name[])
{
  FILE *pFile;
  int i;
  pFile=fopen (name,"wt");
  for (i=0; i<anz; i++)
  fprintf(pFile,"%f\n",vec[i]);
  fclose(pFile);
}
