/* Unterprogramm liest real time clock und stellt PC Uhr danach	*/
unsigned char	h,min,sec;
long int	dos;
int		doswl,doswh;


void set_clock(void)
{
asm {
  mov al,00110100b   /* timer setzen */
	/* 00=counter 0; 11=r/w beide Bytes hintereinander; 010=Modus 2; 0=binr */
  out 43h,al			/* an Steuerregister ausgeben */
  mov al,0				/* niederwertiges Byte low */
  out 40h,al 			/* schreiben */
  mov al,0   			/* hherwertiges Byte low */
  out 40h,al 			/* schreiben */

  mov ah,2      		/* rtc lesen */
  int 1ah
  mov min,cl
  mov h,ch
  mov sec,dh
	 }
h=10*(h/'\x10')+(h & '\xF');
min=10*(min/16)+(min & 15);
sec=10*(sec/16)+(sec & 15);
dos=65543.*h+1092.*min+18.21*sec;
doswl=dos & '\xFF\xFF';
doswh=dos/0x10000;
asm {
  mov ah,1	         /* dosuhr stellen */
  mov cx,doswh
  mov dx,doswl
  int 1ah
	 }
// printf("%2i:%2i:%2i   %x:%x",h,min,sec,doswh,doswl); //Uhrzeit ausgeben
}

void set_timer(unsigned int value)

/* setzt Timer fr IRQ0 mit value */

{
asm {
  mov al,00110100b    /* timer setzen*/
/* 00=counter 0; 11=r/w beide Bytes hintereinander; 010=Modus 2; 0=binr*/
  out 43h,al /* an Steuerregister ausgeben*/
  mov ax,value
  out 40h,al /* niederwertiges Byte schreiben*/
  mov al,ah
  out 40h,al /* hherwertiges Byte schreiben*/
  }
}

void mask_interrupt(char master,char slave)

/* maskiert Master u. Slave- Interrupts */
/* 1b=gesprerrt, 0h=frei */

{
asm {
  mov al,master
  out 21h,al
  mov al,slave
  out 0a1h,al
  }
}

int getkey( void)
{
int key;
key=getch();
if (key==0) key=getch()+256;
return(key);
}
